//+------------------------------------------------------------------+
//|                                             MA_BoomAndCrash4.mq5 |
//|                                  Copyright 2023, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"


#include <Trade/Trade.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int handle;

CTrade trade;
input int slowPeriod = 44; // Moving Average Length
input int pointNum = 100; // Amount of points on MA crossover that should enable a signal


int OnInit()
  {
//---
      handle = iCustom(NULL, 0, "Examples\\MAwithArrows");

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---

      double arrSellSignals[], arrBuySignals[];
       
      CopyBuffer(handle, 0, 0, 1, arrBuySignals);
      CopyBuffer(handle, 1, 0, 1, arrSellSignals);
      
   
      if(arrSellSignals[0] > 0.0){
         for(int i=PositionsTotal()-1; i>=0; i--){
            ulong posTicket = PositionGetTicket(i);
            
            if(posTicket > 0){
               if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY){
                  trade.PositionClose(posTicket); //close this buy position
               }
            }        
         }
         
            if(PositionsTotal() == 0){   
               trade.Sell(0.03); //make one position with lot size 0.03
            }          
      }
         
         
       else if(arrBuySignals[0] > 0.0){
         for(int i=PositionsTotal()-1; i>=0; i--){
            ulong posTicket = PositionGetTicket(i);
            
            if(posTicket>0){
               if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL){
                  trade.PositionClose(posTicket); //close this sell position
               }
            }        
         }    
     
            if(PositionsTotal() == 0){   
               trade.Buy(0.03); //make one position with lot size 0.03
            }
       }
  }
//+------------------------------------------------------------------+
